module Oneshot where

import Order
import DP

type Criterion = Problem -> IO (Maybe Order)

show_proof :: Problem -> Order -> String
show_proof p o =
  show_problem p ++
  "\n" ++
  "The following reduction pair processor removes all rules in P.\n" ++
  "\n" ++
  show o

apply :: [Criterion] -> Problem -> IO (Maybe Order)
apply [] _ = return Nothing
apply (criterion : criteria) problem = do
  result1 <- criterion problem
  case result1 of
    Nothing    -> apply criteria problem
    Just o -> return (Just o)
